summaryrefslogtreecommitdiff
path: root/tests/cp
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2007-06-10 14:56:39 +0200
committerJim Meyering <jim@meyering.net>2007-06-10 15:01:18 +0200
commitb1b0f5c556f5b4080bf16525c309264de73084b7 (patch)
treede1c561b0b228d0495a310358844ae6b87133599 /tests/cp
parent6c95b3f2bf3edfa913a76f83da0c329f1bf0e1ea (diff)
downloadcoreutils-b1b0f5c556f5b4080bf16525c309264de73084b7.tar.xz
bug-fix: cp would fail to write through a dangling symlink
* NEWS: Mention the bug fix. * src/copy.c (copy_reg): When open fails with EEXIST, the destination is lstat'able, and a symlink, call open again, but now without O_EXCL. * tests/cp/thru-dangling: New file, to test for the above fix. * tests/cp/Makefile.am (TESTS): Add thru-dangling. * THANKS: Add Michael McLagan. Bug report from Michael McLagan in <http://bugzilla.redhat.com/243588>.
Diffstat (limited to 'tests/cp')
-rw-r--r--tests/cp/Makefile.am1
-rwxr-xr-xtests/cp/thru-dangling54
2 files changed, 55 insertions, 0 deletions
diff --git a/tests/cp/Makefile.am b/tests/cp/Makefile.am
index 536c0221d..52e876b08 100644
--- a/tests/cp/Makefile.am
+++ b/tests/cp/Makefile.am
@@ -18,6 +18,7 @@
# 02110-1301, USA.
TESTS = \
+ thru-dangling \
cp-a-selinux \
file-perm-race parent-perm-race \
backup-dir \
diff --git a/tests/cp/thru-dangling b/tests/cp/thru-dangling
new file mode 100755
index 000000000..3888cf3d9
--- /dev/null
+++ b/tests/cp/thru-dangling
@@ -0,0 +1,54 @@
+#!/bin/sh
+# Ensure that cp works when the destination is a dangling symlink
+
+# Copyright (C) 2007 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ cp --version
+fi
+
+. $srcdir/../envvar-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+ln -s no-such dangle || framework_failure=1
+echo hi > f || framework_failure=1
+echo hi > exp || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+cp f dangle > out 2>&1 || fail=1
+cat no-such >> out || fail=1
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail